﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinTree;
using Nullable = Infragistics.Win.UltraWinTree.Nullable;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        UltraCheckEditor checkEditor = new UltraCheckEditor();

        public Form1()
        {
            InitializeComponent();

            this.checkEditor.DataFilter = new CheckEditorStringDataFilter();

            this.ultraTree1.Override.CellClickAction = CellClickAction.EditCell;
            this.ultraTree1.ViewStyle = ViewStyle.OutlookExpress;
           
            UltraTreeColumnSet rootColumnSet = this.ultraTree1.ColumnSettings.RootColumnSet;
           
            UltraTreeNodeColumn nameColumn = rootColumnSet.Columns.Add(@"Name");
            nameColumn.DataType = typeof(string);

            UltraTreeNodeColumn valueColumn = rootColumnSet.Columns.Add(@"Value");
            
            this.ultraTree1.ColumnSettings.AutoFitColumns = AutoFitColumns.ResizeAllColumns;

            // add a root node
            UltraTreeNode rootNode = this.ultraTree1.Nodes.Add("Root");
            rootNode.SetCellValue(nameColumn, "Root");

            // add a child
            UltraTreeNode childNode = rootNode.Nodes.Add("Child", "Child");
            childNode.SetCellValue(nameColumn, "Child");

            childNode.Cells[@"Value"].AllowEdit = AllowCellEdit.Full;
            
            childNode.Cells[@"Value"].EditorComponent = this.checkEditor;

            // set the value
            childNode.SetCellValue(valueColumn, false);
        }

        private class CheckEditorStringDataFilter : IEditorDataFilter
        {
            public object Convert(EditorDataFilterConvertArgs conversionArgs)
            {
                switch (conversionArgs.Direction)
                {
                    case ConversionDirection.DisplayToEditor:
                    case ConversionDirection.EditorToDisplay:
                        // Do nothing
                        break;
                    case ConversionDirection.EditorToOwner:
                        conversionArgs.Handled = true;
                        CheckState checkState = (CheckState)Enum.Parse(typeof(CheckState), conversionArgs.Value.ToString());
                        switch (checkState)
                        {
                            case CheckState.Checked:
                                return true;
                            case CheckState.Indeterminate:
                                return null;
                            case CheckState.Unchecked:
                                return false;
                        }
                        break;
                        
                    case ConversionDirection.OwnerToEditor:
                        conversionArgs.Handled = true;
                        return bool.Parse(conversionArgs.Value.ToString());
                }

                return conversionArgs.Value;
            }
        }
    }
}
